<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateAdminUsersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up(): void
    {
        Schema::create('admin_users', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->char('lang', 2)->default('en');
            $table->string('name');
            $table->boolean('is_active')->default(false)->index();
            $table->string('email')->unique();
            $table->timestamp('email_verified_at')->nullable();
            $table->string('password');
            $table->rememberToken();
            $table->timestamps();
        });

        Schema::create('admin_user_roles', function (Blueprint $table) {
            $table->increments('id');
            $table->string('admin_role')->index();
            $table->unsignedBigInteger('admin_user_id');
            $table->boolean('role_status')->index()->default(true);
            $table->timestamps();
        });

        Schema::table('admin_user_roles', function (Blueprint $table) {
            $table->foreign('admin_user_id')->references('id')->on('admin_users');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down(): void
    {
        Schema::dropIfExists('admin_user_roles');
        Schema::dropIfExists('admin_roles');
        Schema::dropIfExists('admin_users');
    }
}
